git-stash.sh 4.5 KB
Newer Older
しらいしななこ 已提交
1 2 3 4 5
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

USAGE='[ | list | show | apply | clear]'

6
SUBDIRECTORY_OK=Yes
しらいしななこ 已提交
7 8
. git-sh-setup
require_work_tree
9
cd_to_toplevel
しらいしななこ 已提交
10 11 12 13 14 15 16

TMP="$GIT_DIR/.git-stash.$$"
trap 'rm -f "$TMP-*"' 0

ref_stash=refs/stash

no_changes () {
17 18
	git diff-index --quiet --cached HEAD &&
	git diff-files --quiet
しらいしななこ 已提交
19 20 21
}

clear_stash () {
22 23 24 25
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
	then
		git update-ref -d refs/stash $current
	fi
しらいしななこ 已提交
26 27 28
}

save_stash () {
29 30
	stash_msg="$1"

しらいしななこ 已提交
31 32 33 34 35 36 37 38
	if no_changes
	then
		echo >&2 'No local changes to save'
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

39 40 41
	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"

しらいしななこ 已提交
42
	# state of the base commit
43
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ 已提交
44
	then
45
		head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
しらいしななこ 已提交
46 47 48 49
	else
		die "You do not have the initial commit yet"
	fi

50
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ 已提交
51 52 53 54 55 56 57 58
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
59
	i_tree=$(git write-tree) &&
しらいしななこ 已提交
60
	i_commit=$(printf 'index on %s' "$msg" |
61
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ 已提交
62 63 64 65
		die "Cannot save the current index state"

	# state of the working tree
	w_tree=$( (
66 67
		rm -f "$TMP-index" &&
		cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
しらいしななこ 已提交
68 69
		GIT_INDEX_FILE="$TMP-index" &&
		export GIT_INDEX_FILE &&
70
		git read-tree -m $i_tree &&
71 72
		git add -u &&
		git write-tree &&
しらいしななこ 已提交
73 74 75 76 77
		rm -f "$TMP-index"
	) ) ||
		die "Cannot save the current worktree state"

	# create the stash
78 79 80 81 82 83 84
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
85
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ 已提交
86 87
		die "Cannot record working tree state"

88
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ 已提交
89
		die "Cannot save the current status"
90
	printf >&2 'Saved "%s"\n' "$stash_msg"
しらいしななこ 已提交
91 92
}

93
have_stash () {
94
	git rev-parse --verify $ref_stash >/dev/null 2>&1
95 96
}

しらいしななこ 已提交
97
list_stash () {
98
	have_stash || return 0
99
	git log --pretty=oneline -g "$@" $ref_stash |
しらいしななこ 已提交
100 101 102 103
	sed -n -e 's/^[.0-9a-f]* refs\///p'
}

show_stash () {
104
	flags=$(git rev-parse --no-revs --flags "$@")
しらいしななこ 已提交
105 106 107 108
	if test -z "$flags"
	then
		flags=--stat
	fi
109
	s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
しらいしななこ 已提交
110

111 112 113
	w_commit=$(git rev-parse --verify "$s") &&
	b_commit=$(git rev-parse --verify "$s^") &&
	git diff $flags $b_commit $w_commit
しらいしななこ 已提交
114 115 116
}

apply_stash () {
117
	git diff-files --quiet ||
しらいしななこ 已提交
118 119
		die 'Cannot restore on top of a dirty state'

120 121 122 123 124 125 126
	unstash_index=
	case "$1" in
	--index)
		unstash_index=t
		shift
	esac

しらいしななこ 已提交
127
	# current index state
128
	c_tree=$(git write-tree) ||
しらいしななこ 已提交
129 130
		die 'Cannot apply a stash in the middle of a merge'

J
Junio C Hamano 已提交
131 132
	# stash records the work tree, and is a merge between the
	# base commit (first parent) and the index tree (second parent).
133 134
	s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
	w_tree=$(git rev-parse --verify "$s:") &&
J
Junio C Hamano 已提交
135 136
	b_tree=$(git rev-parse --verify "$s^1:") &&
	i_tree=$(git rev-parse --verify "$s^2:") ||
しらいしななこ 已提交
137 138
		die "$*: no valid stashed state found"

J
Junio C Hamano 已提交
139 140 141
	unstashed_index_tree=
	if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
	then
142 143 144 145 146 147
		git diff --binary $s^2^..$s^2 | git apply --cached
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
		unstashed_index_tree=$(git-write-tree) ||
			die 'Could not save index tree'
		git reset
J
Junio C Hamano 已提交
148
	fi
149

しらいしななこ 已提交
150 151 152 153 154 155 156 157 158 159 160
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

	if git-merge-recursive $b_tree -- $c_tree $w_tree
	then
		# No conflict
		a="$TMP-added" &&
161 162 163
		git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
		git read-tree --reset $c_tree &&
		git update-index --add --stdin <"$a" ||
しらいしななこ 已提交
164 165
			die "Cannot unstage modified files"
		rm -f "$a"
J
Junio C Hamano 已提交
166 167 168 169 170
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
		fi
		git status || :
しらいしななこ 已提交
171 172
	else
		# Merge conflict; keep the exit status from merge-recursive
173
		status=$?
J
Junio C Hamano 已提交
174 175 176 177
		if test -n "$unstash_index"
		then
			echo >&2 'Index was not unstashed.'
		fi
178
		exit $status
しらいしななこ 已提交
179 180 181 182 183
	fi
}

# Main command set
case "$1" in
184 185
list)
	shift
しらいしななこ 已提交
186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203
	if test $# = 0
	then
		set x -n 10
		shift
	fi
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
apply)
	shift
	apply_stash "$@"
	;;
clear)
	clear_stash
	;;
204 205
help | usage)
	usage
しらいしななこ 已提交
206 207
	;;
*)
208 209 210 211 212 213
	if test $# -gt 0 && test "$1" = save
	then
		shift
	fi
	save_stash "$*" && git-reset --hard
	;;
しらいしななこ 已提交
214
esac